
;
; Some functions that are commonly provided in other Scheme implementations
;

(define 1+ add1)
(define 1- sub1)

(define =? =)
(define <? <)
(define >? >)
(define <=? <)
(define >=? >)

(define gentemp gensym)

(defmacro define-structure (name-and-fields)
  `(define-struct ,(car name-and-fields) ,(cdr name-and-fields)))

(define sort ; quicksort
  (lambda (l less-than?)
    (let* ([v (list->vector l)]
	   [count (vector-length v)])
      (let loop ([min 0][max count])
	(if (< min (sub1 max))
	    (let ([pval (vector-ref v min)])
	      (let pivot-loop ([pivot min]
			       [pos (add1 min)])
		(if (< pos max)
		    (let ([cval (vector-ref v pos)])
		      (if (less-than? cval pval)
			  (begin
			    (vector-set! v pos (vector-ref v pivot))
			    (vector-set! v pivot cval)
			    (pivot-loop (add1 pivot) (add1 pos)))
			  (pivot-loop pivot (add1 pos))))
		    (if (= min pivot)
			(loop (add1 pivot) max)
			(begin
			  (loop min pivot)
			  (loop pivot max))))))))
      (vector->list v))))

