
(define mred:autoload-paths '("/usr/local/lib/mred/mzscheme/"))

(define make-autoload
  (lambda (name file)
    (lambda args
      (if (defined? name)
	  (apply (eval name) args)
	  (catch escape
		 (let ([path (wx:path-only file)]
		       [try-it
			(lambda (file)
			  (load/cd file)
			  (if (defined? name)
			      (escape (apply (eval name) args))
			      (error "Undefined after autoloading: " name)))])
		   (if (null? path)
		       (begin
			 (for-each
			  (lambda (dir)
			    (let ([file (string-append dir file)])
			      (when (wx:file-exists? file)
				    (try-it file))))
			  mred:autoload-paths)
			 (error "Unable to find autoload file: " file))
		       (try-it file))))))))
(constant make-autoload)

(defmacro define-autoload (name file)
  `(define ,name
     (let ([auto (make-autoload (quote ,name) ,file)]
	   [used? #f])
       (lambda args
	 (if used?
	     (error "Undefined after autoloading: " (quote ,name))
	     (dynamic-wind
	      (lambda ()
		(set! used? #t))
	      (lambda ()
		(apply auto args))
	      (lambda ()
		(set! used? #f))))))))



