
(define mred:find-string-frame%
  (make-class wx:frame%
	      (inherit
	       set-client-size
	       show
	       make-modal
	       capture-mouse
	       release-mouse)
	      (class
	       [WIDTH 450]
	       [HEIGHT 100]
	       [canvas% mred:canvas%]
	       [edit% mred:edit%])
	      (private
	       edit
	       canvas

	       top-panel

	       allow-return-check-box

	       find-canvas
	       find-edit

	       middle-panel
	       middle-panel2

	       replace-canvas
	       replace-edit

	       bottom-panel

	       done-button

	       wrap-check-box
	       backwards-check-box
	       replace-check-box
	       ignore-case-check-box

	       find-button find-button-2
	       replace-button
	       replace-and-find-button
	       replace-all-button

	       short-height
	       long-height
	       
	       [allow-carriage-returns #f]
	       use-capture?)
	      
	      (public
	       [finder-keymap
		(lambda (edit)
		  (let ([keymap (send edit get-keymap)])
		    (send keymap add-key-function
			  "return"
			  (lambda args
			    (if allow-carriage-returns
				#f
				(on-find))))
		    (send keymap add-key-function
			  "forward"
			  (lambda args
			    (send backwards-check-box set-value #f)
			    (on-find)))
		    (send keymap add-key-function
			  "reverse"
			  (lambda args
			    (send backwards-check-box set-value #t)
			    (on-find)))
		    (send keymap add-key-function
			  "done"
			  (lambda args (on-done)))
		    (send keymap add-key-function
			  "tab"
			  (lambda args
			    (if (send replace-check-box get-value)
				(if (send find-canvas is-focus-on?)
				    (send replace-canvas set-focus)
				    (send find-button-2 set-focus))
				(send find-button set-focus))))

		    (send keymap map-function "return" "return")
		    (send keymap map-function "c:s" "forward")
		    (send keymap map-function "c:r" "reverse")
		    (send keymap map-function "c:x;c:c" "done")
		    (send keymap map-function "tab" "tab")))]

	       [on-done
		(lambda args
		  (send canvas force-display-focus #f)
		  (if use-capture?
		      (release-mouse)
		      (make-modal #f))
		  (show #f))]

	       [on-replace-check
		(lambda (button event)
		  (if (send event checked?)
		      (begin
			(send find-button show #f)
			(set-client-size WIDTH long-height))
		      (begin
			(send find-button show #t)
			(set-client-size WIDTH short-height))))]

	       [on-return-check
		(lambda (button event)
		  (set! allow-carriage-returns (send event checked?)))]
	       
	       [on-backwards-check
		(lambda args #f)]
	       [on-wrap-check
		(lambda args #f)]
	       [on-ignore-case-check
		(lambda args #f)]

	       [do-find
		(opt-lambda (f [bell wx:bell]
			       [end (if (send backwards-check-box get-value)
					0 
					(send edit last-position))]
			       [wrap-ok #t])
		  (set! done-find #t)
		  (let* ([backwards (send backwards-check-box get-value)]
			 [caseless (send ignore-case-check-box get-value)]
			 [direction (if backwards -1 1)]
			 [start (if backwards
				    (send edit get-start-position)
				    (send edit get-end-position))]
			 [text (send find-edit get-text)]
			 [sos (not backwards)]
			 [next (send edit find-string text direction 
				     start end
				     sos (not caseless))])
		    (if (>= next 0)
			(f next (+ next (string-length text)))
			(if (and wrap-ok (send wrap-check-box get-value))
			    (let* ([new-start
				    (if backwards
					(send edit last-position)
					0)]
				   [next (send edit find-string text direction
					       new-start start sos
					       (not caseless))])
			      (if (>= next 0)
				  (f next (+ next (string-length text)))
				  (bell)))
			    (bell)))))]



	       [on-find
		(lambda args
		  (do-find (lambda (start end)
			     (send edit set-position start end))))]
			      
	       [on-replace
		(lambda args
		  (let ([text (send replace-edit get-text)])
		    (send edit insert text)))]
	       [done-find #f]
	       [on-replace-and-find
		(lambda args
		  (if done-find (on-replace))
		  (on-find))]

	       [on-replace-all
		(lambda args
		  (dynamic-wind
		   (lambda ()
		     (send edit begin-edit-sequence))
		   (lambda ()
		     (let* ([backwards (send backwards-check-box get-value)]
			    [dir-check (if backwards > <)]
			    [real-start (send edit get-start-position)])
		       (letrec ([text (send replace-edit get-text)]
				[repl-&-find
				 (lambda (start end)
				   (send edit set-position start end)
				   (send edit insert text start end)
				   (if (< start
					  real-start)
				       (set! real-start 
					     (+ real-start (string-length text)
						(- start end))))
				   (if (dir-check start real-start)
				       (do-find repl-&-find (lambda () #t)
						real-start #f)
				       (do-find repl-&-find (lambda () #t))))])
			 (do-find repl-&-find (lambda () #t)))))
		   (lambda ()
		     (send edit end-edit-sequence))))]

	       [on-size
		(lambda (w h)
		  (set! WIDTH w)
		  (send top-panel set-size -1 -1 w -1)
		  (send find-canvas set-size -1 -1 w HEIGHT)
		  (send middle-panel set-size -1 -1 w -1)
		  (send middle-panel2 set-size -1 -1 w -1)
		  (send replace-canvas set-size -1 -1 w HEIGHT)
		  (send bottom-panel set-size -1 -1 w -1))])


	      (opt-lambda (in-canvas [in-edit ()] [x -1] [y -1] [flags ()])
		(set! canvas in-canvas)
		(set! edit (if (null? in-edit)
			       (send in-canvas get-media)
			       in-edit))
		(super-init () "Find String" x y)

		(let ([h-box (box 0)]
		      [y-box (box 0)]
		      [w-box (box 0)])
		  
		  (set! top-panel
			(make-object wx:panel% this))
		  
		  (make-object wx:message% top-panel "Find:")

		  (set! allow-return-check-box
			(make-object wx:check-box%
				     top-panel on-return-check
				     "Carriage Returns in Search"))
		  
		  (set! done-button
			(make-object wx:button%
				     top-panel on-done
				     "Done"))
		  (send done-button get-position (box 0) y-box)
		  (send done-button get-size w-box h-box)
		  (send done-button set-size
			(- WIDTH (unbox w-box) 20) (unbox y-box)
			(unbox w-box) (unbox h-box))
		  
		  (send top-panel fit)
		  (send top-panel get-size (box 0) h-box)
		  
		  (set! find-canvas
			(make-object mred:canvas%
				     this 0 (unbox h-box)
				     WIDTH HEIGHT))

		  (set! find-edit (send find-canvas get-media))
		  (finder-keymap find-edit)

		  (send find-canvas get-size (box 0) h-box)
		  (send find-canvas get-position (box 0) y-box)

		  (set! middle-panel
			(make-object wx:panel% this
				     0 (+ (unbox y-box) (unbox h-box))))
		  
		  (set! find-button
			(make-object wx:button%
				     middle-panel on-find
				     "Find"))

		  (set! backwards-check-box
			(make-object wx:check-box%
				     middle-panel on-backwards-check
				     "Reverse"))

		  (set! wrap-check-box
			(make-object wx:check-box%
				     middle-panel on-wrap-check
				     "Wraparound"))

		  (set! ignore-case-check-box
			(make-object wx:check-box%
				     middle-panel on-ignore-case-check
				     "Ignore Case"))

		  (set! replace-check-box
			(make-object wx:check-box%
				     middle-panel on-replace-check
				     "Replace..."))

		  (send middle-panel new-line)

		  (send middle-panel fit)
		  
		  (send middle-panel get-size (box 0) h-box)
		  (send middle-panel get-position (box 0) y-box)

		  (set! short-height (+ (unbox h-box) (unbox y-box)))

		  (set! middle-panel2
			(make-object wx:panel% this
				     0 (+ (unbox y-box) (unbox h-box))))
		  
		  (send middle-panel get-size (box 0) h-box)
		  (send middle-panel get-position (box 0) y-box)

		  (make-object wx:message% middle-panel2 "Replace:")
		  
		  (send middle-panel2 new-line)
		  (send middle-panel2 fit)
		  
		  (send middle-panel2 get-size (box 0) h-box)
		  (send middle-panel2 get-position (box 0) y-box)

		  (set! replace-canvas
			(make-object mred:canvas%
				     this 0 (+ (unbox y-box) (unbox h-box))
				     WIDTH HEIGHT))
		  
		  (set! replace-edit (send replace-canvas get-media))
		  (finder-keymap replace-edit)

		  (send replace-canvas get-size (box 0) h-box)
		  (send replace-canvas get-position (box 0) y-box)

		  (set! bottom-panel
			(make-object wx:panel% this
				     0 (+ (unbox y-box) (unbox h-box))))

		  (set! find-button-2
			(make-object wx:button%
				     bottom-panel on-find
				     "Find"))

		  (set! replace-button
			(make-object wx:button%
				     bottom-panel on-replace
				     "Replace"))
		  (set! replace-and-find-button
			(make-object wx:button%
				     bottom-panel on-replace-and-find
				     "Replace and Find Again"))

		  (set! replace-all-button
			(make-object wx:button%
				     bottom-panel on-replace-all
				     "Replace All"))
		 
		  (send bottom-panel new-line)
		  (send bottom-panel fit)

		  (send bottom-panel get-size (box 0) h-box)
		  (send bottom-panel get-position (box 0) y-box)

		  (set! long-height (+ (unbox h-box) (unbox y-box)))

		  (set-client-size WIDTH short-height)

		  (if (member 'replace flags)
		      (send replace-check-box set-value #t))
		  (if (member 'reverse flags)
		      (send backwards-check-box set-value #t))
		  (if (member 'ignore-case flags)
		      (send ignore-case-check-box set-value #t))
		  (if (member 'wraparound flags)
		      (send wraparound-check-box set-value #t))

		  (show #t)
		  (send canvas force-display-focus #t)

		  ; The problem with make-modal in X is that it does
		  ; not let the current focus-owning Widget to get
		  ; an unfocus event. capture-mouse does what we
		  ; really want in X, but not in Windows
		  (set! use-capture? (eq? mred:platform 'unix))

		  (if use-capture?
		      (capture-mouse)
		      (make-modal #t))

		  (send find-canvas set-focus)))))

