
; Pick one:
; (define mred:startup-print-status (lambda (x) (display x) (newline)))
(define mred:startup-print-status (lambda (x) #f))

(mred:startup-print-status "Loading macros...")
(load "macros.ss")
(mred:startup-print-status "Loading functions...")
(load "function.ss")

(mred:startup-print-status "Loading match...")
(load "match.ss")

(mred:startup-print-status "Loading error...")
(load "error.ss")

(mred:startup-print-status "Loading autoload...")
(load "autoload.ss")

(mred:startup-print-status "Loading strings...")
(load "strings.ss")
(mred:startup-print-status "Loading exit...")
(load "exit.ss")
(mred:startup-print-status "Loading file...")
(load "file.ss")
(mred:startup-print-status "Loading keys...")
(load "keys.ss")

(mred:startup-print-status "Loading match cache...")
(load "mcache.ss")
(mred:startup-print-status "Loading parens...")
(load "paren.ss")
(mred:startup-print-status "Loading Scheme parens...")
(load "sparen.ss")

(mred:startup-print-status "Loaing misc...")
(load "misc.ss")

(mred:startup-print-status "Loaing wxbasic...")
(load "wxbasic.ss")

(mred:startup-print-status "Loading pretty-print...")
(load "pretty.ss")

(mred:startup-print-status "Loading finder...")
(load "finder.ss")

(mred:startup-print-status "Loading icon...")
(load "icon.ss")

(mred:startup-print-status "Loading frame...")
(load "frame.ss")
(mred:startup-print-status "Loading buffer...")
(load "buffers.ss")

(mred:startup-print-status "Loading console...")
(load "console.ss")

(mred:startup-print-status "Loading find string...")
(load "findstr.ss")

(mred:startup-print-status "Loading scheme mode...")
(load "ssmode.ss")

(mred:startup-print-status "Loading hyper...")
(load/cd "hyper/load.ss")

(define mred:console-frame (void))
(define mred:console-canvas (void))
(define mred:console-edit (void))

(define mred:startup
  (lambda args
    (if (null? args)
	(let ((frame (make-object mred:console-frame% #f)))
	  (set! mred:console-frame frame)
	  (set! mred:console-canvas (ivar frame canvas))
	  (set! mred:console-edit (ivar frame edit))
	  frame)
	(let loop ([args args])
	  (if (null? args)
	      (mred:startup)
	      (let ([arg (car args)])
		(cond
		 [(string-ci=? "-f" arg)
		  (let loop ([args (cdr args)])
		    (if (null? args)
			(mred:startup)
			(begin
			  (load-with-cd (car args))
			  (loop (cdr args)))))]
		 [(string-ci=? "-e" arg)
		  (if (null? (cdr args))
		      (error "expected a string to evaluate after -e flag")
		      (eval-string (cadr args)))
		  (loop (cddr args))]
		 [else (loop (cdr args))])))))))

(define mred:user-setup
  (lambda ()
    (let* ([home (wx:get-home-dir)]
	   [home (if (string? home)
		     (string-append home "/")
		     "")]
	   [file (string-append home 
				(if (eq? mred:platform 'windows)
				    "mredrc.ss"
				    ".mredrc"))])
      (if (wx:file-exists? file)
	  (load-with-cd file)))))

; This should be configurable:
(if (eq? mred:platform 'unix)
    (wx:set-afm-path "/usr/local/transcript-4.0/lib/"))

