
; Scheme parenthesis wrappers around the general routines

(define mred:std-scheme-paren-pairs '(("(" . ")")
				  ("[" . "]")))
(constant mred:std-scheme-paren-pairs)
(define mred:scheme-paren-pairs mred:std-scheme-paren-pairs)

(define mred:std-scheme-quote-pairs '(("\"" . "\"")))
(constant mred:std-scheme-quote-pairs)
(define mred:scheme-quote-pairs mred:std-scheme-quote-pairs)

(define mred:std-scheme-comments '(";"))
(constant mred:std-scheme-comments)
(define mred:scheme-comments mred:std-scheme-comments)

(define mred:scheme-forward-match
  (lambda (edit start end)
    (mred:forward-match edit start end
                        mred:scheme-paren-pairs
                        mred:scheme-quote-pairs
                        mred:scheme-comments)))
(constant mred:scheme-forward-match)

(define mred:scheme-backward-match
  (opt-lambda (edit start end [cache #f])
    (mred:backward-match edit start end
                         mred:scheme-paren-pairs
                         mred:scheme-quote-pairs
                         mred:scheme-comments
                         #f
			 cache)))
(constant mred:scheme-backward-match)

(define mred:scheme-balanced?
  (lambda (edit start end)
    (mred:balanced? edit start end
                    mred:scheme-paren-pairs
                    mred:scheme-quote-pairs
                    mred:scheme-comments)))
(constant mred:scheme-balanced?)


(define mred:scheme-backward-containing-sexp
  (opt-lambda (edit start end [cache #f])
    (mred:backward-match edit start end
                         mred:scheme-paren-pairs
                         mred:scheme-quote-pairs
                         mred:scheme-comments
                         #t
			 cache)))
(constant mred:scheme-backward-containing-sexp)

