
#define CURSOR_WIDTH 2

/* WARNING: This structure is *NOT* garbage-collected.
   It could be, but it doesn't need to be right now. */

class wxMediaLine /* : wxObject - Uncomment for GC */
{
 public:
  wxMediaLine *next, *prev, *parent, *left, *right;
  long flags;

  /* relative values: */
  long line;   // line number
  long pos;    // starting item position
  long scroll; // starting scroll step
  float y;     // starting y location
  
  float maxWidth;

  class wxSnip *snip, *lastSnip, *scrollSnip;

  long len, numscrolls;
  float lastH, lastW; /* height/width of last snip in line */
  float h, w; /* height/width of line */
  float bottombase, topbase; /* bottom baseline, top baseline (relative) */

  wxMediaLine();
  ~wxMediaLine();

  wxMediaLine *Insert(wxMediaLine **root, Bool before = TRUE);
  void Delete(wxMediaLine **root);

  wxMediaLine *FindLine(long line);
  wxMediaLine *FindPosition(long pos);
  wxMediaLine *FindScroll(long scroll);
  wxMediaLine *FindLocation(float y);

  long GetLine();
  long GetPosition();
  long GetScroll();
  float GetLocation();

  float ScrollOffset(long p);
  long FindExtraScroll(float y);

  void SetLength(long len);
  void CalcLineLength();
  void SetScrollLength(long numScrolls);
  void SetHeight(float h);

  void SetWidth(float w);
  void MarkRecalculate();
  void MarkCheckFlow();

  wxMediaLine *GetRoot();

  Bool UpdateFlow(wxMediaLine **root, wxMediaEdit *, float maxw, wxDC *dc);
  Bool UpdateGraphics(wxMediaEdit *media, wxDC *dc);

  long Number();
  wxMediaLine *First();
  wxMediaLine *Last();

 private:
  void AdjustOffsets(wxMediaLine *newchild);
  void DeadjustOffsets(wxMediaLine *oldchild);

  void RotateLeft(wxMediaLine **root);
  void RotateRight(wxMediaLine **root);
  void AdjustNeedCalc(Bool recur = FALSE);
  void AdjustNeedFlow(Bool recur = FALSE);
  void AdjustMaxWidth(Bool recur = FALSE);
};

extern wxMediaLine *NIL;
