
#include "wx.h"
#include "wx_timer.h"

#ifdef wx_msw
#include <dir.h>
#endif

#if USE_METAFILE
#include "wx_mf.h"
#endif

@INCLUDE wxs.xci

@HEADER

#ifdef wx_x
#define FILE_SEL_DEF_PATTERN "*"
#else
#define FILE_SEL_DEF_PATTERN "*.*"
#endif

#define BUF_SIZE 1000
static char buffer[BUF_SIZE];

static char *wxGetHostName_Scheme(void)
{
  wxGetHostName(buffer, BUF_SIZE);
  
  return buffer;
}
static char *wxGet_Scheme(Bool (*f)(char *, int))
{
  if (!f(buffer, BUF_SIZE))
    return NULL;
  else
    return buffer;
}

static char *wxExpandPath_Scheme(char *path)
{
  return wxExpandPath(buffer, (const char *)path);
}

static char *wxGetEmailAddress_Scheme(void)
{
  return wxGet_Scheme(wxGetEmailAddress);
}

static char *wxGetUserId_Scheme(void)
{
  return wxGet_Scheme(wxGetUserId);
}

static char *wxGetUserName_Scheme(void)
{
  return wxGet_Scheme(wxGetUserName);
}

static char *wxGetHomeDir_Scheme(void)
{
#ifdef wx_msw
  return NULL;
#else
  return wxGetHomeDir(buffer);
#endif
}

static char *wxStripMenuCodes_Scheme(char *in)
{
  static char *buffer = NULL;
  static long buflen = 0;
  long len;

  len = strlen(in);
  if (buflen <= len) {
    if (buffer)
      delete[] buffer;
    buflen = 2 * len + 1;
    buffer = new char[buflen];
  }

  wxStripMenuCodes(in, buffer);
  return buffer;
}

#ifndef wx_x
Bool wxSetDisplay(char *display_name)
{
  return FALSE;
}

char *wxGetDisplayName(void)
{
  return NULL;
}
#endif

@GLOBAL wxsGlobal

@ "wx:dir-exists?" : bool DirExists(string);
@ "wx:file-exists?" : bool FileExists(string);
@ "wx:file-name-from-path" : string FileNameFromPath(string);
@ "wx:is-absolute-path?" : bool IsAbsolutePath(string);
@ "wx:path-only" : string PathOnly(string);
@ "wx:concat-files" : bool wxConcatFiles(string,string,string);
@ "wx:expand-path" : string wxExpandPath_Scheme(string);
@ "wx:copy-file" : bool wxCopyFile(string,string);
@ "wx:get-working-directory" : string wxGetWorkingDirectory();
@ "wx:set-working-directory" : void wxSetWorkingDirectory(string);
@ "wx:get-temp-file-name" : string wxGetTempFileName(string);
@ "wx:is-wild?" : bool wxIsWild(string);
@ "wx:match-wild?" : bool wxMatchWild(string,string,bool);
@ "wx:mkdir" : bool wxMkdir(string);
// Doesn't exist? @ "wx:rmdir" : bool wxRmdir(string);
@ "wx:remove-file" : bool wxRemoveFile(string);
@ "wx:rename-file" : bool wxRenameFile(string,string);
@ "wx:get-user-home" : string wxGetUserHome(ncstring=NULL);

@ "wx:get-host-name" : string wxGetHostName_Scheme();
@ "wx:get-home-dir" : string wxGetHomeDir_Scheme();
@ "wx:get-email-address" : string wxGetEmailAddress_Scheme();
@ "wx:get-user-id" : string wxGetUserId_Scheme();
@ "wx:get-user-name" : string wxGetUserName_Scheme();

@ "wx:string-match?" : bool StringMatch(string,string,bool=TRUE,bool=FALSE);

@ "wx:set-display" : bool wxSetDisplay(nstring);
@ "wx:get-display-name" : nstring wxGetDisplayName();

@ "wx:exit" : void wxExit();

@ "wx:file-selector" : string wxFileSelector(string,nstring=NULL,nstring=NULL,nstring=NULL,string=FILE_SEL_DEF_PATTERN,int=0,wxWindow!=NULL,int=-1,int=-1);
@ "wx:message-box" : int wxMessageBox(string, string="Message",int=wxOK|wxCENTER,wxWindow!=NULL,int=-1,int=-1);
@ "wx:get-text-from-user" : string wxGetTextFromUser(string,string="Input text",string="",wxWindow^=NULL,int=-1,int=-1,bool=TRUE);

@SET TYPE = string
@SET NOTEST = 1
@SET NULLTERM = 1
@INCLUDE list.xci

// @ "wx:get-multiple-choice" : int wxGetMultipleChoice(string,string,-int,string[]/bList/ubList/cList,-int,int*,wxWindow^=NULL,int=-1,int=-1,bool=TRUE,int=150,int=200); : /// : /glueListSet[string.3.2]/glueCleanup[string]/

@ "wx:get-single-choice" : string wxGetSingleChoice(string,string,-int,string[]/bList/ubList/cList,wxWindow^=NULL,int=-1,int=-1,bool=TRUE,int=150,int=200); : /// : /glueListSet[string.2.3.2]/glueCleanup[3]/
@ "wx:get-single-choice-index" : int wxGetSingleChoiceIndex(string,string,-int,string[]/bList/ubList/cList,wxWindow^=NULL,int=-1,int=-1,bool=TRUE,int=150,int=200); : /// : /glueListSet[string.2.3.2]/glueCleanup[3]/
@ "wx:get-single-choice-data" : string wxGetSingleChoiceData(string,string,-int,string[]/bList/ubList/cList,string[]/bList/ubList/cList,wxWindow^=NULL,int=-1,int=-1,bool=TRUE,int=150,int=200); : /// : /glueListSet[string.2.3.2]|glueListSet[string.3.4.2]/glueCleanup[3] | glueCleanup[4] /

@ "wx:colour-display?" : bool wxColourDisplay();
@ "wx:display-depth" : int wxDisplayDepth();

#if !USE_METAFILE
#define wxMakeMetaFilePlaceable(a,b,c,d,e,f) TRUE
#endif
@ "wx:make-meta-file-placeable" : bool wxMakeMetaFilePlaceable(string,float,float,float,float,float);

@ "wx:set-cursor" : void wxSetCursor(wxCursor!);

@ "wx:get-printer-command" : string wxGetPrinterCommand();
@ "wx:get-printer-file" : string wxGetPrinterFile();
// @ "wx:get-printer-preview-command" : string wxGetPrinterPreviewCommand();
@ "wx:get-printer-mode" : int wxGetPrinterMode();
@ "wx:get-printer-orientation" : int wxGetPrinterOrientation();
@ "wx:get-printer-options" : string wxGetPrinterOptions();
@ "wx:get-printer-scaling" : void wxGetPrinterScaling(float*,float*);
@ "wx:get-printer-translation" : void wxGetPrinterTranslation(float*,float*);
@ "wx:get-afm-path" : nstring wxGetAFMPath();

@ "wx:set-printer-command" : void wxSetPrinterCommand(string);
@ "wx:set-printer-file" : void wxSetPrinterFile(string);
// @ "wx:set-printer-preview-command" : void wxSetPrinterPreviewCommand(string);
@ "wx:set-printer-mode" : void wxSetPrinterMode(int);
@ "wx:set-printer-orientation" : void wxSetPrinterOrientation(int);
@ "wx:set-printer-options" : void wxSetPrinterOptions(string);
@ "wx:set-printer-scaling" : void wxSetPrinterScaling(float,float);
@ "wx:set-printer-translation" : void wxSetPrinterTranslation(float,float);
@ "wx:set-afm-path" : void wxSetAFMPath(nstring);

@ "wx:new-id" : int NewId();
@ "wx:register-id" : void RegisterId(long);

@ "wx:begin-busy-cursor" : void wxBeginBusyCursor(wxCursor!=wxHOURGLASS_CURSOR);
@ "wx:is-busy?" : bool wxIsBusy();
@ "wx:end-busy-cursor" : void wxEndBusyCursor();
@ "wx:bell" : void wxBell();
@ "wx:display-size" : void wxDisplaySize(int*,int*);

@ "wx:error" : void wxError(string,string="wxWindows Internal Error");
@ "wx:fatal-error" : void wxFatalError(string,string="wxWindows Fatal Error");

@ "wx:execute" : void wxExecute(string,bool=FALSE);
@ "wx:execute" : void wxExecute(string[]/bList/ubList/cList,bool=FALSE); : /// : /glueUncountedListSet[string.0.0]/glueCleanup[0]/
@ "wx:shell" : void wxShell(string);

@ "wx:find-first-file" : string wxFindFirstFile(cstring, int=0);
@ "wx:find-next-file" : nstring wxFindNextFile();

@ "wx:find-menu-item-id" : int wxFindMenuItemId(wxFrame!,string,string);
@ "wx:find-window-by-label" : wxWindow^ wxFindWindowByLabel(string,wxWindow^=NULL);
@ "wx:find-window-by-name" : wxWindow^ wxFindWindowByName(string,wxWindow^=NULL);
@ "wx:strip-menu-codes" : string wxStripMenuCodes_Scheme(string);

@ "wx:get-elapsed-time" : long wxGetElapsedTime(bool=TRUE);
@ "wx:sleep" : void wxSleep(int);
@ "wx:start-timer" : void wxStartTimer();

@ "wx:sub-type?" : bool wxSubType(int,int);

@ "wx:to-lower" : char wxToLower(char);
@ "wx:to-upper" : char wxToUpper(char);

@ "wx:get-free-memory" : long wxGetFreeMemory();
@ "wx:get-os-version" : int wxGetOsVersion(int?,int?);

@ "wx:get-resource" : bool wxGetResource(string,string,string*,nstring=NULL);
@ "wx:get-resource" : bool wxGetResource(string,string,long*,nstring=NULL);
@ "wx:write-resource" : bool wxWriteResource(string,string,string,nstring=NULL);
@ "wx:write-resource" : bool wxWriteResource(string,string,long,nstring=NULL);

@ "wx:yield" : bool wxYield();

@CONSTANT "wx:const-ok" : int wxOK
@CONSTANT "wx:const-yes-no" : int wxYES_NO
@CONSTANT "wx:const-cancel" : int wxCANCEL
@CONSTANT "wx:const-yes" : int wxYES
@CONSTANT "wx:const-no" : int wxNO

@CONSTANT "wx:const-icon-exclamation" : int wxICON_EXCLAMATION
@CONSTANT "wx:const-icon-hand" : int wxICON_HAND
@CONSTANT "wx:const-icon-question" : int wxICON_QUESTION
@CONSTANT "wx:const-icon-information" : int wxICON_INFORMATION

@CONSTANT "wx:const-icon-stop" : int wxICON_STOP
@CONSTANT "wx:const-icon-asterisk" : int wxICON_ASTERISK
@CONSTANT "wx:const-icon-mask" : int wxICON_MASK

@CONSTANT "wx:const-center" : int wxCENTER
@CONSTANT "wx:const-centre" : int wxCENTRE

@END
